import { ClientContext } from './client_context';
import { FeatureStateHolder } from './feature_state';
import { FeatureStateValueInterceptor } from './interceptors';
import { AnalyticsCollector } from './analytics';
import { InternalFeatureRepository } from './internal_feature_repository';
export declare enum Readyness {
    NotReady = "NotReady",
    Ready = "Ready",
    Failed = "Failed"
}
export interface ReadynessListener {
    (state: Readyness): void;
}
export interface PostLoadNewFeatureStateAvailableListener {
    (repo: InternalFeatureRepository): void;
}
export interface FeatureHubRepository {
    readyness: Readyness;
    catchAndReleaseMode: boolean;
    logAnalyticsEvent(action: string, other?: Map<string, string>, ctx?: ClientContext): any;
    hasFeature(key: string): undefined | FeatureStateHolder;
    feature(key: string): FeatureStateHolder;
    getFeatureState(key: string): FeatureStateHolder;
    release(disableCatchAndRelease?: boolean): Promise<void>;
    simpleFeatures(): Map<string, string | undefined>;
    getFlag(key: string): boolean | undefined;
    getString(key: string): string | undefined;
    getJson(key: string): string | undefined;
    getNumber(key: string): number | undefined;
    isSet(key: string): boolean;
    addValueInterceptor(interceptor: FeatureStateValueInterceptor): void;
    addReadynessListener(listener: ReadynessListener): void;
    addAnalyticCollector(collector: AnalyticsCollector): void;
    addPostLoadNewFeatureStateAvailableListener(listener: PostLoadNewFeatureStateAvailableListener): any;
}
