import { ObjectSerializer } from './models/models/model_serializer';
class BrowserFeaturePostUpdater {
    post(url, update) {
        return new Promise((resolve) => {
            const req = new XMLHttpRequest();
            req.open('PUT', url);
            req.setRequestHeader('Content-type', 'application/json');
            req.send(JSON.stringify(ObjectSerializer.serialize(update, 'FeatureStateUpdate')));
            req.onreadystatechange = function () {
                if (req.readyState === 4) {
                    resolve(req.status >= 200 && req.status < 300);
                }
            };
        });
    }
}
export class FeatureUpdater {
    constructor(config) {
        this.sdkUrl = config.url();
        this.manager = FeatureUpdater.featureUpdaterProvider();
    }
    updateKey(key, update) {
        return this.manager.post(this.sdkUrl + '/' + key, update);
    }
}
FeatureUpdater.featureUpdaterProvider = () => new BrowserFeaturePostUpdater();
//# sourceMappingURL=test_sdk.js.map